
(* ESERCIZIO: 
Si utilizzi (nel top level evaluator di OCaml) il comando {\tt \#use "List.ml"} per 
visionare le signature di tutte le operazioni della libreria List. Alcune di queste 
operazioni sono implementate tail-recursive altre no: Si veda il link 
{\tt http://caml.inria.fr/pub/docs/manual-ocaml/libref/List.html}
\begin{itemize}
\item [a.] Si individui l'operazione "exists" e si mostri come pu\`o essere utilizzata 
nella definizione dell'operazione "isin", introdotta ieri per l'appartenenza di un valore 
ad una lista;
\item [b.] Si fornisca una definizione della funzione reverse che inverte liste polimorfe
\item [c.] Si fornisca una definizione tail-recursive di reverse
\item [d.] Si confrontino le 2 definizioni tra loro e con le funzioni List.rev e 
List.rev$\_$append (facendo anche uso della funzione "elapsedTime" nei listing allegato)

SOLUZIONE *)

(* una funzione per misurare il tempo di esecuzione di un'invocazione *)
let elapsedTime f x =
    let t = Sys.time() in
    let fx = f x in
    Printf.printf "elapsed time: %fs\n" (Sys.time() -. t); fx;;

a.




b.





c.





