package SmallCDclINF;

import java.io.*;
import java.util.*;


interface Dcl{//un tipo unione
    public String toString();
    public void print();
}

class Const implements Dcl{
    public String ide;
    public int val;
    Const(String ide, int val){
        this.ide = ide;
        this.val = val;
    }
    public String toString(){
        return ide + " = " + Integer.toString(val) + ";";
    }
    public void print(){
        System.out.println(toString());
    }
}

class Var implements Dcl{
    public String ide;
    public int val;
    Var(String ide, int val){
        this.ide = ide;
        this.val = val;
    }
    public String toString(){
        return "var " + ide + " = " + Integer.toString(val) + ";";
    }
    public void print(){
        System.out.println(toString());
    }
}

class VarN implements Dcl{
    public String ide;
    VarN(String ide){
        this.ide = ide;
    }
    public String toString(){
        return "var " + ide + ";";
    }
    public void print(){
        System.out.println(toString());
    }
}

class Array implements Dcl{
    public String ide;
    public int size;
    Array(String ide, int size){
        this.ide = ide;
        this.size = size;
    }
    public String toString(){
        return ide + "[" + Integer.toString(size) + "];";
    }
    public void print(){
        System.out.println(toString());
    }
}

class SeqDcl implements Dcl{
    public Dcl dL;
    public Dcl dR;
    SeqDcl(Dcl left, Dcl right){
        dL = left;
        dR = right;
    }
    public String toString(){
        return dL.toString() + dR.toString();
    }
    public void print(){
        dL.print();
        dR.print();
    }
}
    

